# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Automation::Mgmt::V2015_10_31
  module Models
    #
    # Definition of the runbook type.
    #
    class Runbook < TrackedResource

      include MsRestAzure

      # @return [RunbookTypeEnum] Gets or sets the type of the runbook.
      # Possible values include: 'Script', 'Graph', 'PowerShellWorkflow',
      # 'PowerShell', 'GraphPowerShellWorkflow', 'GraphPowerShell'
      attr_accessor :runbook_type

      # @return [ContentLink] Gets or sets the published runbook content link.
      attr_accessor :publish_content_link

      # @return [RunbookState] Gets or sets the state of the runbook. Possible
      # values include: 'New', 'Edit', 'Published'
      attr_accessor :state

      # @return [Boolean] Gets or sets verbose log option.
      attr_accessor :log_verbose

      # @return [Boolean] Gets or sets progress log option.
      attr_accessor :log_progress

      # @return [Integer] Gets or sets the option to log activity trace of the
      # runbook.
      attr_accessor :log_activity_trace

      # @return [Integer] Gets or sets the job count of the runbook.
      attr_accessor :job_count

      # @return [Hash{String => RunbookParameter}] Gets or sets the runbook
      # parameters.
      attr_accessor :parameters

      # @return [Array<String>] Gets or sets the runbook output types.
      attr_accessor :output_types

      # @return [RunbookDraft] Gets or sets the draft runbook properties.
      attr_accessor :draft

      # @return [RunbookProvisioningState] Gets or sets the provisioning state
      # of the runbook. Possible values include: 'Succeeded'
      attr_accessor :provisioning_state

      # @return [String] Gets or sets the last modified by.
      attr_accessor :last_modified_by

      # @return [DateTime] Gets or sets the creation time.
      attr_accessor :creation_time

      # @return [DateTime] Gets or sets the last modified time.
      attr_accessor :last_modified_time

      # @return [String] Gets or sets the description.
      attr_accessor :description

      # @return [String] Gets or sets the etag of the resource.
      attr_accessor :etag


      #
      # Mapper for Runbook class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Runbook',
          type: {
            name: 'Composite',
            class_name: 'Runbook',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              location: {
                client_side_validation: true,
                required: false,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              runbook_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.runbookType',
                type: {
                  name: 'String'
                }
              },
              publish_content_link: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.publishContentLink',
                type: {
                  name: 'Composite',
                  class_name: 'ContentLink'
                }
              },
              state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.state',
                type: {
                  name: 'String'
                }
              },
              log_verbose: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.logVerbose',
                type: {
                  name: 'Boolean'
                }
              },
              log_progress: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.logProgress',
                type: {
                  name: 'Boolean'
                }
              },
              log_activity_trace: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.logActivityTrace',
                type: {
                  name: 'Number'
                }
              },
              job_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.jobCount',
                type: {
                  name: 'Number'
                }
              },
              parameters: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.parameters',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'RunbookParameterElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'RunbookParameter'
                      }
                  }
                }
              },
              output_types: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.outputTypes',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              draft: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.draft',
                type: {
                  name: 'Composite',
                  class_name: 'RunbookDraft'
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'Enum',
                  module: 'RunbookProvisioningState'
                }
              },
              last_modified_by: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.lastModifiedBy',
                type: {
                  name: 'String'
                }
              },
              creation_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.creationTime',
                type: {
                  name: 'DateTime'
                }
              },
              last_modified_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.lastModifiedTime',
                type: {
                  name: 'DateTime'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.description',
                type: {
                  name: 'String'
                }
              },
              etag: {
                client_side_validation: true,
                required: false,
                serialized_name: 'etag',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
